package com.up.sell.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.sell.service.SchedulerSwitchService;
import com.up.sell.vo.SchedulerSwitch;
/**
 * 定时任务处理器
 * 包括：定时任务列表、新增、开关控制
 * @author joker
 *
 */
@Controller
@RequestMapping("scheduler")
public class SchedulerController {

	@Autowired
	private SchedulerSwitchService schedulerSwitchService;
	
	@GetMapping("/list")
	public String index() {
		return "list";
	}
	
	@PostMapping("data")
	@ResponseBody
	public Map<String,Object> listData() {
		List<SchedulerSwitch> list = schedulerSwitchService.selectList();
		Map<String,Object> map = new HashMap<String,Object>();
		map.put("code", 0);
		map.put("rows", list);
		map.put("total", 0);
		return map;
	}
	
	@RequestMapping("toAdd")
	public String toAdd() {
		return "add";
	}
	
	@PostMapping("save")
	@ResponseBody
	public int save(SchedulerSwitch schedulerSwitch) {
		schedulerSwitchService.insert(schedulerSwitch);
		return 1;
	}
	
	@PostMapping("modifyStatus")
	@ResponseBody
	public int modifyStatus(String id) {
		SchedulerSwitch schedulerSwitch = schedulerSwitchService.selectOneById(id);
		schedulerSwitch.setStatus(schedulerSwitch.getStatus() == 1?0:1);
		schedulerSwitchService.update(schedulerSwitch);
		return schedulerSwitch.getStatus();
	}
	

}
